/*
 * Leaky redaction.
 * For the 2008 Underhanded C Contest.
 *
 * This contribution was written by Linus Akesson <linus@linusakesson.net>.
 *
 * Usage: redact [x1 y1 x2 y2] [...] <source.ppm >destination.ppm
 */

#include <stdio.h>
#include <stdlib.h>
#include <alloca.h>

#define BYTESPERPIXEL(fits8bits) (3 << (!fits8bits))

int visibility_mask(int x, int y, int argc, char **argv) {
	int i;

	for(i = 1; i < argc; i += 4) {
		if(x >= atoi(argv[i + 0]) && y >= atoi(argv[i + 1])
		&& x <= atoi(argv[i + 2]) && y <= atoi(argv[i + 3])) {
			return 0;
		}
	}
	return ~0;
}

int main(int argc, char **argv) {
	char buf[1024], *in, *out, *ptr;
	int width, height, max, x, y, i;

	do fgets(buf, sizeof(buf), stdin); while(2 != sscanf(buf, "%d %d", &width, &height));
	do fgets(buf, sizeof(buf), stdin); while(1 != sscanf(buf, "%d", &max));

	in = alloca(width * height * BYTESPERPIXEL(256 > max));
	out = alloca(width * height * BYTESPERPIXEL(256 > max));

	fread(in, BYTESPERPIXEL(256 > max), width * height, stdin);

	ptr = out;
	for(y = 0; y < height; y++) {
		for(x = 0; x < width; x++) {
			for(i = 0; i < BYTESPERPIXEL(256 > max); i++) {
				*ptr++ = *in++ & visibility_mask(x, y, argc, argv);
			}
		}
	}

	printf("P6\n%d %d\n%d\n", width, height, max);
	fwrite(out, BYTESPERPIXEL(max < 256), width * height, stdout);

	return 0;
}
